package com.fp.persistence.pgeneral.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEUSERSOLICITUDENUMBER*/
@Entity(name="TgeneUserSolicitudeNumber")
@Table(name="TGENEUSERSOLICITUDENUMBER")
public class TgeneUserSolicitudeNumber extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneUserSolicitudeNumber
*/
@Id
@Column(name="USERCODE" ,nullable=false, updatable=false)
private String pk;
@Column(name="SOLICITUDNUMBER", nullable=true)

/**
* Numero de secuencia de solicitud asociada al usuario.
*/
private String solicitudnumber;

/**Contructor por defecto*/
public TgeneUserSolicitudeNumber(){
}
/**Contructor de TgeneUserSolicitudeNumber
@param pPk Clave Primaria del entity
*/
public TgeneUserSolicitudeNumber(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneUserSolicitudeNumber
*/
public static TgeneUserSolicitudeNumber find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneUserSolicitudeNumber obj = pEntityManager.find(TgeneUserSolicitudeNumber.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneUserSolicitudeNumber
@return El objeto que referencia a la Clave primaria de TgeneUserSolicitudeNumber
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneUserSolicitudeNumber
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneUserSolicitudeNumber
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de solicitudnumber
@return valor de solicitudnumber*/
public String getSolicitudnumber(){
  return solicitudnumber;
}
/**Fija el valor de solicitudnumber
@param pSolicitudnumber nuevo Valor de solicitudnumber*/
public void setSolicitudnumber(String pSolicitudnumber){
  solicitudnumber=pSolicitudnumber;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneUserSolicitudeNumber))return false;
    TgeneUserSolicitudeNumber that = (TgeneUserSolicitudeNumber) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneUserSolicitudeNumber
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneUserSolicitudeNumber
*/
public Object createInstance(){
 TgeneUserSolicitudeNumber instance=new TgeneUserSolicitudeNumber();	
 return instance;
}
/**Clona la entidad TgeneUserSolicitudeNumber
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneUserSolicitudeNumber p=(TgeneUserSolicitudeNumber)this.clone();
  return p;
}
}
